#!/usr/bin/python3
# -*- coding: utf-8 -*-

import dbus.service

class AccessDeniedException(dbus.DBusException):
    '''This exception is raised when some operation is not permitted.'''

    _dbus_error_name = 'cn.kylinos.KylinUpdateManager.AccessDeniedException'


class PolicyKitService(dbus.service.Object):
    '''A D-BUS service that uses PolicyKit for authorization.'''

    #
    # 函数：检查dbus permission
    #
    def _check_permission(self, msg,action, sender):
        if not sender:
            raise ValueError('sender == None')
        details = {'polkit.message':msg}
        cancel_id = ''
        kit = dbus.SystemBus().get_object('org.freedesktop.PolicyKit1', '/org/freedesktop/PolicyKit1/Authority')
        kit = dbus.Interface(kit, 'org.freedesktop.PolicyKit1.Authority')
        (granted, notused , details) = kit.CheckAuthorization(
                        ('system-bus-name', {'name': sender}),
                        action, details, dbus.UInt32(1),cancel_id, timeout=600)
        return granted
